# Carbon Aware SDK

The Carbon Aware SDK exists to enable developers to build Carbon-Aware applications that do more when clean electricity 
is available, and less when it is not. 

Consumption of the SDK requires an API deployment that implements the documented interfaces. 

Find out more about the [SDK](https://github.com/Green-Software-Foundation/carbon-aware-sdk) and the 
[Green Software Foundation](https://greensoftware.foundation/).

This Dart package was generated by the [OpenAPI Generator](https://openapi-generator.tech) project.


## Documentation for API Endpoints

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*CarbonAwareApi* | [**batchForecastDataAsync**](doc//CarbonAwareApi.md#batchforecastdataasync) | **POST** /emissions/forecasts/batch | Given an array of historical forecasts, retrieves the data that contains  forecasts metadata, the optimal forecast and a range of forecasts filtered by the attributes [start...end] if provided.
*CarbonAwareApi* | [**getAverageCarbonIntensity**](doc//CarbonAwareApi.md#getaveragecarbonintensity) | **GET** /emissions/average-carbon-intensity | Retrieves the measured carbon intensity data between the time boundaries and calculates the average carbon intensity during that period.
*CarbonAwareApi* | [**getAverageCarbonIntensityBatch**](doc//CarbonAwareApi.md#getaveragecarbonintensitybatch) | **POST** /emissions/average-carbon-intensity/batch | Given an array of request objects, each with their own location and time boundaries, calculate the average carbon intensity for that location and time period   and return an array of carbon intensity objects.
*CarbonAwareApi* | [**getBestEmissionsDataForLocationsByTime**](doc//CarbonAwareApi.md#getbestemissionsdataforlocationsbytime) | **GET** /emissions/bylocations/best | Calculate the best emission data by list of locations for a specified time period.
*CarbonAwareApi* | [**getCurrentForecastData**](doc//CarbonAwareApi.md#getcurrentforecastdata) | **GET** /emissions/forecasts/current | Retrieves the most recent forecasted data and calculates the optimal marginal carbon intensity window.
*CarbonAwareApi* | [**getEmissionsDataForLocationByTime**](doc//CarbonAwareApi.md#getemissionsdataforlocationbytime) | **GET** /emissions/bylocation | Calculate the best emission data by location for a specified time period.
*CarbonAwareApi* | [**getEmissionsDataForLocationsByTime**](doc//CarbonAwareApi.md#getemissionsdataforlocationsbytime) | **GET** /emissions/bylocations | Calculate the observed emission data by list of locations for a specified time period.


## Documentation For Models

 - [CarbonIntensityBatchParametersDTO](doc//CarbonIntensityBatchParametersDTO.md)
 - [CarbonIntensityDTO](doc//CarbonIntensityDTO.md)
 - [EmissionsData](doc//EmissionsData.md)
 - [EmissionsDataDTO](doc//EmissionsDataDTO.md)
 - [EmissionsForecastBatchParametersDTO](doc//EmissionsForecastBatchParametersDTO.md)
 - [EmissionsForecastDTO](doc//EmissionsForecastDTO.md)
 - [ValidationProblemDetails](doc//ValidationProblemDetails.md)


## Author

Green Software Foundation

